//
//  CLStaticTableViewCell.m
//  CLStaticTableViewItem
//
//  Created by hezhijingwei on 16/6/30.
//  Copyright © 2016年 秦传龙. All rights reserved.
//

#import "CLStaticTableViewCell.h"
#import "CLStaticDefineHeader.h"
#import "CLBadgeValue.h"
#import "CLCommonArrowItem.h"
#import "CLCommonLabel.h"
#import "CLCommonSwitchItem.h"

@interface CLStaticTableViewCell ()

@property (nonatomic ,strong) UIImageView *rightArrow;

@property (nonatomic ,strong) UISwitch *rightSwitch;

@property (nonatomic ,strong) UILabel *rightLabel;

@property (nonatomic ,strong) CLBadgeValue *badgeView;


@end


@implementation CLStaticTableViewCell

- (void)awakeFromNib {
    [super awakeFromNib];
    
}

- (void)layoutSubviews {
    
    [super layoutSubviews];
    self.detailTextLabel.x = CGRectGetMinX(self.accessoryView.frame) - self.detailTextLabel.width - 8;
    
}


- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        
        self.textLabel.font         = [UIFont systemFontOfSize:15];
        self.detailTextLabel.font   = [UIFont systemFontOfSize:12];
        self.backgroundColor        = [UIColor whiteColor];
        self.selectedBackgroundView = [[UIImageView alloc] init];
        
        
    }
    
    return self;
    
}

- (CLBadgeValue *)badgeView {
    
    if (!_badgeView) {
        _badgeView = [[CLBadgeValue alloc] init];
    }
    
    return _badgeView;
}



- (UIImageView *)rightArrow {
    
    if (nil == _rightArrow) {
        _rightArrow = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"rightArrow"]];
        _rightArrow.size = CGSizeMake(self.height/4, self.height/2.5);
    }
    return _rightArrow;
    
}

- (UISwitch *)rightSwitch {
    
    
    if (nil == _rightSwitch) {
        _rightSwitch = [[UISwitch alloc] init];
        [_rightSwitch addTarget:self action:@selector(valueChanged:) forControlEvents:UIControlEventValueChanged];
    }
    
    return _rightSwitch;
}

- (void)valueChanged:(UISwitch *)rightSwitch {
    
    CLCommonSwitchItem *item = (CLCommonSwitchItem *)self.item;
    
    if (item.valueChange) {
        
        if (rightSwitch.isOn) {
            item.valueChange(YES);
        } else {
            item.valueChange(NO);
        }
        
    }
    
    
}


- (UILabel *)rightLabel {
    
    if (nil == _rightLabel) {
        _rightLabel               = [[UILabel alloc] init];
        _rightLabel.textColor     = [UIColor lightGrayColor];
        _rightLabel.numberOfLines = 0;
        _rightLabel.font          = CLLabelFont(12);
    }
    
    return _rightLabel;
    
}

- (void)setItem:(CLStaticItem *)item {
    
    _item = item;
    
    self.textLabel.text       = item.title;
    self.detailTextLabel.text = item.subTitle;
    
    if (item.icon) {
        self.imageView.image  = [UIImage imageNamed:item.icon];
    }
    
    if (item.badgeValue) {
        self.badgeView.badgeValue = item.badgeValue;
        self.accessoryView = self.badgeView;
    } else if ([item isKindOfClass:[CLCommonArrowItem class]]) {
        
        self.accessoryView = self.rightArrow;
        
    } else if ([item isKindOfClass:[CLCommonSwitchItem class]]) {
        
        self.accessoryView = self.rightSwitch;
        
        
    } else if ([item isKindOfClass:[CLCommonLabel class]]) {
        
        
        CLCommonLabel *labelItem = (CLCommonLabel *)item;
        
        self.rightLabel.size     = [labelItem.text boundingRectWithSize:CGSizeMake(200, MAXFLOAT)
                                                                options:NSStringDrawingUsesLineFragmentOrigin
                                                             attributes:@{
                                                                          NSFontAttributeName:CLLabelFont(12)}
                                                                context:nil].size;
        self.rightLabel.text     = labelItem.text;
        
        self.accessoryView       = self.rightLabel;
    }
    
    
}

- (void)setFrame:(CGRect)frame {
    frame.size.height -= 1;
    [super setFrame:frame];
}


- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    
    
    if (selected == YES && [_item isKindOfClass:[CLCommonLabel class]]) {
       
        CLCommonLabel *item = (id)_item;
        if (item.block) {
            item.block();
        }
    }
   
}

@end
